package com.mygrouptasks.thiscontent.config;

import com.mygrouptasks.thiscontent.entities.Authorities;
import com.mygrouptasks.thiscontent.entities.Users;
import com.mygrouptasks.thiscontent.repository.AuthoritiesRepository;
import com.mygrouptasks.thiscontent.repository.UsersRepository;
import com.mygrouptasks.thiscontent.service.AuthoritiesService;
import com.mygrouptasks.thiscontent.service.UsersService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class UserDetailsServiceImpl implements UserDetailsService {


    @Autowired
    UsersService usersService;

    @Autowired
    AuthoritiesService authoritiesService;

    @Autowired
    PasswordEncoder passwordEncoder;

    public String userDetailsServiceMethod(String username) {
        Users user = usersService.returnByUsername(username);
        return user.getUsername();
    }

    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        System.out.println("- at userDetails loadUserByUsername with username: < " + username + " > ...");

        /*Users user = new Users(); //usersService.returnByUsername(username);
        user.setUsername("admin");
        user.setPassword(passwordEncoder.encode("admin"));
        user.setEnabled(true);*/

        Users user = usersService.returnByUsername(username);

        System.out.println("-UserDetailsService... username received: " + username + "\n" +
           "- processing with user object for: " + user.getUsername());

        User.UserBuilder builder = null;
        if (user != null) {
            builder = org.springframework.security.core.userdetails.User.withUsername(username);
            System.out.println("- preparing the builder...\n" +
                    "- roles: " + builder.roles() + "\n" +
                    "- toString: " + builder.toString());
            builder.password(user.getPassword());
            builder.disabled(false);
            builder.accountExpired(false);
            builder.credentialsExpired(false);
            builder.accountLocked(false);
            // builder.authorities(this.getGrantedAuthorities(user));
            builder.authorities(authoritiesService.returnRole(username));

                //builder.roles("ROLE_USER");

                //builder.roles(user.getRoles()) //should users table have a roles field? show I retrieve roles from
                //authorities table? can I escape having roles field in the builder and it'd be okay with
                //userDetailsService?
            }

            return builder.build();
    }
}
