package com.mygrouptasks.thiscontent.controller;

import com.mygrouptasks.thiscontent.config.UserDetailsServiceImpl;
import com.mygrouptasks.thiscontent.entities.Users;
import com.mygrouptasks.thiscontent.service.UsersService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.ArrayList;
import java.util.List;

@Controller
public class UserController {

    @Autowired
    UsersService usersService;

    @Autowired
    UserDetailsServiceImpl userDetailsServiceImpl;

    @PostMapping("/destroy")
    public String destroySession(HttpServletRequest request) {
        request.getSession().invalidate();
        return "redirect:/";
    }

    @PostMapping("/persistMessage")
    public String persistMessage(@RequestParam("msg") String msg, HttpServletRequest request) {
        @SuppressWarnings("unchecked")
        List<String> msgs = (List<String>) request.getSession().getAttribute("MY_SESSION_MESSAGES");
        if (msgs == null) {
            msgs = new ArrayList<>();
            request.getSession().setAttribute("MY_SESSION_MESSAGES", msgs);
        }
        msgs.add(msg);
        request.getSession().setAttribute("MY_SESSION_MESSAGES", msgs);
        return "redirect:/";
    }

    //session get or set
    @GetMapping("/")
    public String welcome (Model model, HttpSession session) {
        System.out.println("- start page here");

        @SuppressWarnings("unchecked")
        List<String> messages = (List<String>) session.getAttribute("MY_SESSION_MESSAGES");

        if (messages==null) {
            messages = new ArrayList<>();
        }
        model.addAttribute("sessionMessages", messages);
        model.addAttribute("sessionId", session.getId());

        return "welcome";
    }

    @GetMapping("/checkusersservice")
    public void checkusersservice()
    {
        System.out.println("- accessing userDetailsServiceImpl with username <admin> returned: " +
                userDetailsServiceImpl.userDetailsServiceMethod("admin"));
    }

    @GetMapping("/registeruser")
    public String registerWithBcrypt()
    {
        System.out.println("- register a user using bcrypt...");
        Users user1 = new Users();
        user1.setUsername("bob3");
        user1.setPassword("pass");
        user1.setEnabled(true);
        usersService.saveUser(user1, "ROLE_USER");
        return "/registered";
    }

    @GetMapping("/loginSecureSuccess")
    public String loginSecureGet() {
        System.out.println("- log in get");
        return ("test");
    }


    @PostMapping("/loginSecure")
    public String loginPost() {
        System.out.println("- log in post");
        return ("userLoggedInPage");
    }

    @GetMapping("/login")
    public String login()
    {
        System.out.println("login...");
        return "/login";
    }

    @GetMapping("/user")
    public String user (Model model) {
        System.out.println("- user page here");
        return "userpage";
    }

    @GetMapping("/admin")
    public String admin (Model model) {
        System.out.println("- admin page here");
        return "admin";
    }

    @GetMapping("/403")
    public String error403() {
        return "/error/403";
    }


}
