package com.mygrouptasks.thiscontent.repository;

import com.mygrouptasks.thiscontent.entities.Authorities;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

@Transactional(readOnly = false)
@Repository
public interface AuthoritiesRepository extends CrudRepository<Authorities,String> {


    //@Query(value="select u from Users u where u.user_id =:id")
    //Users findById(@Param("id") int id);


    @Query(value="select a from Authorities a where a.username =:username")
    Authorities findAuthoritiesByUsername(@Param("username") String username);

    @Modifying
    @Query(value="insert into Authorities (username, authority) values(:username, :authority)", nativeQuery = true)
    void insertIntoAuthorities(@Param("username") String username, @Param("authority") String authority);


}


