package com.mygrouptasks.thiscontent.service;

import com.mygrouptasks.thiscontent.entities.Users;
import com.mygrouptasks.thiscontent.repository.AuthoritiesRepository;
import com.mygrouptasks.thiscontent.repository.UsersRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

@Service
//@Component
public class UsersService {

    @Autowired
    private PasswordEncoder passwordEncoder;

    @Autowired
    private UsersRepository usersRepository;

    @Autowired
    private AuthoritiesRepository authoritiesRepository;

    @Autowired
    private AuthoritiesService authoritiesService;

    public void saveUser(Users user, String role) {
        user.setPassword(passwordEncoder.encode(user.getPassword()));
        usersRepository.save(user);
        authoritiesService.saveAuthority(user.getUsername(), role);
        //authoritiesRepository.insertIntoAuthorities(user.getUsername(),role);
        System.out.println("- user saved.");
    }

    /*public Users returnById (int user_id) {
        Users thisUser = usersRepository.findById(user_id);
        return thisUser;
    }*/

    public Users returnByUsername (String username) {
        Users thisUser = usersRepository.findByUsername(username);
        System.out.println("- finding and returning user: < " + thisUser.getUsername() + " >");
        return thisUser;
    }

}
